/*  tilp - a linking program for TI graphing calculators
 *  Copyright (C) 1999-2002  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __BMPFILE_H__
#define __BMPFILE_H__

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef __WIN32__

/* Memo: windef.h */
/*
	BYTE:  8 bits unsigned
	WORD:  16 bits unsigned
	DWORD: 32 bits unsigned
	LONG:  32 bits signed
*/

#else

#include <sys/types.h>
#include <stdint.h>

typedef uint8_t  BYTE;
typedef uint16_t WORD;
typedef uint32_t DWORD;
typedef int32_t  LONG;

typedef struct tagBITMAPFILEHEADER { // bmfh 
    WORD    bfType; 
    DWORD   bfSize; 
    WORD    bfReserved1; 
    WORD    bfReserved2; 
    DWORD   bfOffBits; 
} BITMAPFILEHEADER;


typedef struct tagBITMAPINFOHEADER{ // bmih 
    DWORD  biSize; 
    LONG   biWidth; 
    LONG   biHeight; 
    WORD   biPlanes; 
    WORD   biBitCount; 
    DWORD  biCompression; 
    DWORD  biSizeImage; 
    LONG   biXPelsPerMeter; 
    LONG   biYPelsPerMeter; 
    DWORD  biClrUsed; 
    DWORD  biClrImportant; 
} BITMAPINFOHEADER; 


typedef struct tagRRGGBB{ 
   BYTE RR; 
   BYTE GG; 
   BYTE BB; 
} RRGGBB; 


#define BI_RGB  0L                  /*No compression */

#endif

typedef struct tagICONENTRY {
  BYTE    bWidth;
  BYTE    bHeight;
  BYTE    bColorCount;
  BYTE    bReserved;
  WORD    wPlanes;
  WORD    bBitCount;
  DWORD   dwSizeInBytes;
  DWORD   dwFileOffset;
} ICONENTRY;

#endif
